get_ap:
	// %rdi = r, %rsi = idx
	// r->a[idx] is at offset 4*idx from r
	leaq	(%rdi,%rsi,4), %rax
	ret // return r + 4*idx

set_val:
	// %rdi = r, %esi = val
	// Jump to condition.
	jmp	.L3
.L4:    // Body:
        // %rax = r->i   (at offset 16 == 4*sizeof(r->a))
	movq	16(%rdi), %rax
	// r->a[idx] = val  (32-bit move)
	movl	%esi, (%rdi,%rax,4)
	// r = r->next   (at offset 24 == 16 + sizeof(r->i))
	movq	24(%rdi), %rdi
.L3:    // Condition
	testq	%rdi, %rdi
	// If %rdi is not zero, continue
	jne	.L4
	rep ret
.LC0:
	.string	"Node at %p: %zu [%d %d %d %d] -> %p\n"
main:
	pushq	%r12
	pushq	%rbp
	pushq	%rbx
	subq	$32, %rsp
	movl	$32, %esi
	movl	$1, %edi
	call	calloc
	movq	%rax, %rbp
	movl	$32, %esi
	movl	$1, %edi
	call	calloc
	movq	%rax, %r12
	movq	$1, 16(%rbp)
	movq	$2, 16(%rax)
	movq	%rax, 24(%rbp)
	movq	$0, 24(%rax)
	movl	$0, %esi
	movq	%rbp, %rdi
	call	get_ap
	movl	$4, (%rax)
	movl	$8, %esi
	movq	%rbp, %rdi
	call	set_val
	movq	%rbp, %rbx
	jmp	.L6
.L7:
	movq	24(%rbx), %rsi
	movl	12(%rbx), %edx
	movl	8(%rbx), %eax
	movl	4(%rbx), %r9d
	movl	(%rbx), %r8d
	movq	16(%rbx), %rcx
	movq	%rsi, 16(%rsp)
	movl	%edx, 8(%rsp)
	movl	%eax, (%rsp)
	movq	%rbx, %rdx
	movl	$.LC0, %esi
	movl	$1, %edi
	movl	$0, %eax
	call	__printf_chk
	movq	24(%rbx), %rbx
.L6:
	testq	%rbx, %rbx
	jne	.L7
	movq	%rbp, %rdi
	call	free
	movq	%r12, %rdi
	call	free
	movl	$0, %eax
	addq	$32, %rsp
	popq	%rbx
	popq	%rbp
	popq	%r12
	ret
